openapi: 3.0.0
info:
  title: Projet Backend
  description: 'Projet réalisé dans son intégralité contenant un client, un serveur passerelle d"authentification, un serveur principal gérant les demandes et une base de données. La présence de fichier "DockerFile" rend le programme déployable sur docker.' 
  version: 1.0.0
paths:
  /PATIENT:
    get:
      summary: Permet de récupérer tous les patients
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema: 
                type: string
        '400':
          description: Une erreur serveur est survenue
  /PATIENT/{id}:
    get:
      summary: Permet de récupérer un patients avec son id
      parameters:
        - name: id
          schema: 
            type: number
          required: true
          in: path
      responses:
        '200':
          description: OK
          content:
            text/plain:
              schema:
                type: string
        '400':
          description: Une erreur serveur est survenue
    delete:
      summary: Permet de supprimer un patients avec son id
      parameters:
        - name: id
          schema: 
            type: number
          required: true
          in: path
      responses:
        '200':
          description: OK
          content:
            text/plain:
              schema:
                type: string
        '400':
          description: Une erreur serveur est survenue
  /PATIENT/{nom}/{prenom}:
    post:
      summary: Permet d"ajouter un patient.
      parameters:
        - name: nom
          schema: 
            type: string
          required: true
          in: path
        - name: prenom
          schema: 
            type: string
          required: true
          in: path
      responses:
        '201':
          description: Create
          content:
            application/json:
              schema: 
                type: string
        '400':
          description: Une erreur serveur est survenue
  /PATIENT/{id}/MALADIE:
    get:
      summary: Permet de récupérer un patients avec son id. Affiche en plus sont historique de maladies.
      parameters:
        - name: id
          schema: 
            type: number
          required: true
          in: path
      responses:
        '200':
          description: OK
          content:
            text/plain:
              schema:
                type: string
        '400':
          description: Une erreur serveur est survenue
  /PATIENT//MALADIE:
    get:
      summary: Permet de récupérer tous les patients. Affiche en plus leurs historiques de maladies.
      responses:
        '200':
          description: OK
          content:
            text/plain:
              schema:
                type: string
        '400':
          description: Une erreur serveur est survenue
  /PATIENT/{id}/MEDICAMENT:
    get:
      summary: Permet de récupérer un patients avec son id. Affiche en plus ces prescriptions.
      parameters:
        - name: id
          schema: 
            type: number
          required: true
          in: path
      responses:
        '200':
          description: OK
          content:
            text/plain:
              schema:
                type: string
        '400':
          description: Une erreur serveur est survenue
  /PATIENT//MEDICAMENT:
    get:
      summary: Permet de récupérer tous les patients. Affiche en plus leurs prescriptions. 
      responses:
        '200':
          description: OK
          content:
            text/plain:
              schema:
                type: string
        '400':
          description: Une erreur serveur est survenue
  /PATIENT/{id}/ALL:
    get:
      summary: Permet de récupérer un patients avec son id.Affiche en plus sont historique de maladies. Affiche en plus ces prescriptions.
      parameters:
        - name: id
          schema: 
            type: number
          required: true
          in: path
      responses:
        '200':
          description: OK
          content:
            text/plain:
              schema:
                type: string
        '400':
          description: Une erreur serveur est survenue
  /PATIENT//ALL:
    get:
      summary: Permet de récupérer un patients avec son id.  Affiche en plus leurs historiques de maladies. Affiche en plus leurs prescriptions. 
      responses:
        '200':
          description: OK
          content:
            text/plain:
              schema:
                type: string
        '400':
          description: Une erreur serveur est survenue
  /MALADIE:
    get:
      summary: Permet de récupérer toutes les maladies
      responses:
        '200':
          description: OK
          content:
            text/plain:
              schema:
                type: string
        '400':
          description: Une erreur serveur est survenue
  /MALADIE/{id}:
    get:
      summary: Permet de récupérer une maladie avec son id
      parameters:
        - name: id
          schema: 
            type: number
          required: true
          in: path
      responses:
        '200':
          description: OK
          content:
            text/plain:
              schema:
                type: string
        '400':
          description: Une erreur serveur est survenue
    delete:
      summary: Permet de supprimer une maladie avec son id
      parameters:
        - name: id
          schema: 
            type: number
          required: true
          in: path
      responses:
        '200':
          description: OK
          content:
            text/plain:
              schema:
                type: string
        '400':
          description: Une erreur serveur est survenue
  /MALADIE/{libelle}:
    post:
      summary: Permet d"ajouter une maladie.
      parameters:
        - name: libelle
          schema: 
            type: string
          required: true
          in: path
      responses:
        '201':
          description: Create
          content:
            application/json:
              schema: 
                type: string
        '400':
          description: Une erreur serveur est survenue
  /MALADIE//PATIENT:
    get:
      summary: Permet de récupérer toutes les maladies. Affiche en plus les patients.
      responses:
        '200':
          description: OK
          content:
            text/plain:
              schema:
                type: string
        '400':
          description: Une erreur serveur est survenue
  /MALADIE/{id}/PATIENT:
    get:
      summary: Permet de récupérer une maladie avec son id. Affiche en plus le patient.
      parameters:
        - name: id
          schema: 
            type: number
          required: true
          in: path
      responses:
        '200':
          description: OK
          content:
            text/plain:
              schema:
                type: string
        '400':
          description: Une erreur serveur est survenue
  /MEDICAMENT:
    get:
      summary: Permet de récupérer tout les medicaments
      responses:
        '200':
          description: OK
          content:
            text/plain:
              schema:
                type: string
        '400':
          description: Une erreur serveur est survenue
  /MEDICAMENT/{id}:
    get:
      summary: Permet de récupérer un medicaments avec son id
      parameters:
        - name: id
          schema: 
            type: number
          required: true
          in: path
      responses:
        '200':
          description: OK
          content:
            text/plain:
              schema:
                type: string
        '400':
          description: Une erreur serveur est survenue
    delete:
      summary: Permet de supprimer un medicaments avec son id
      parameters:
        - name: id
          schema: 
            type: number
          required: true
          in: path
      responses:
        '200':
          description: OK
          content:
            text/plain:
              schema:
                type: string
        '400':
          description: Une erreur serveur est survenue
  /MEDICAMENT/{libelle}:
    post:
      summary: Permet d"ajouter un medicament.
      parameters:
        - name: libelle
          schema: 
            type: string
          required: true
          in: path
      responses:
        '201':
          description: Create
          content:
            application/json:
              schema: 
                type: string
        '400':
          description: Une erreur serveur est survenue
  /MEDICAMENT//PATIENT:
    get:
      summary: Permet de récupérer tout les medicaments. Affiche en plus les patients.
      responses:
        '200':
          description: OK
          content:
            text/plain:
              schema:
                type: string
        '400':
          description: Une erreur serveur est survenue
  /MEDICAMENT/{id}/PATIENT:
    get:
      summary: Permet de récupérer un medicament avec son id. Affiche en plus le patient.
      parameters:
        - name: id
          schema: 
            type: number
          required: true
          in: path
      responses:
        '200':
          description: OK
          content:
            text/plain:
              schema:
                type: string
        '400':
          description: Une erreur serveur est survenue
  /MALADIEPATIENT/{patientID}/{maladieID}:
    post:
      summary: Permet d"ajouter une maladie à un patient
      parameters:
        - name: patientID
          schema: 
            type: number
          required: true
          in: path
        - name: maladieID
          schema: 
            type: number
          required: true
          in: path
      responses:
        '201':
          description: Create
          content:
            application/json:
              schema: 
                type: string
        '400':
          description: Une erreur serveur est survenue  
    delete:
      summary: Permet de supprimer une maladie à un patient
      parameters:
        - name: patientID
          schema: 
            type: number
          required: true
          in: path
        - name: maladieID
          schema: 
            type: number
          required: true
          in: path
      responses:
        '201':
          description: Create
          content:
            application/json:
              schema: 
                type: string
        '400':
          description: Une erreur serveur est survenue  
      
  /PRESCRIPTION/{patientID}/{medicamentID}:
    post:
      summary: Permet d"ajouter une prescription à un patient.
      parameters:
        - name: patientID
          schema: 
            type: number
          required: true
          in: path
        - name: medicamentID
          schema: 
            type: number
          required: true
          in: path
      responses:
        '201':
          description: Create
          content:
            application/json:
              schema: 
                type: string
        '400':
          description: Une erreur serveur est survenue
    delete:
      summary: Permet d"ajouter une prescription à un patient.
      parameters:
        - name: patientID
          schema: 
            type: number
          required: true
          in: path
        - name: medicamentID
          schema: 
            type: number
          required: true
          in: path
      responses:
        '201':
          description: Create
          content:
            application/json:
              schema: 
                type: string
        '400':
          description: Une erreur serveur est survenue
  /PRESCRIPTION/{patientID}/{ancMedicamentID}/{newMedicamentID}:
    put:
      summary: Permet de changer le mediament d'une prescription.
      parameters:
        - name: patientID
          schema: 
            type: number
          required: true
          in: path
        - name: ancMedicamentID
          description: ID de l'ancien médicament prescrit.
          schema: 
            type: number
          required: true
          in: path
        - name: newMedicamentID
          description: ID du nouveau médicament prescrit.
          schema: 
            type: number
          required: true
          in: path
      responses:
        '201':
          description: Create
          content:
            application/json:
              schema: 
                type: string
        '400':
          description: Une erreur serveur est survenue    
          
          
          
          
          
          
          
          
          
          
          
          
          
          
          
          
          
          
          